// hash.h

#ifndef HASH_H
#define HASH_H

// includes
#include "board.h"

// macros
#define KEY_INDEX(key) ((uint32)(key))
#define KEY_LOCK(key)  ((uint32)((key)>>32))

// variables
extern uint64 castle_64[16];

// functions
extern void hash_init();
extern uint64 hash_key(const board_t *board);
extern uint64 hash_pawn_key(const board_t *board);
extern uint64 hash_material_key(const board_t *board);
extern uint64 hash_piece_key(int piece, int square);
extern uint64 hash_castle_key(int flags);
extern uint64 hash_ep_key(int square);
extern uint64 hash_turn_key(int color);

#endif // !defined HASH_H
// end of hash.h
