// main.cpp

// includes
#include <cstdio>
#include <cstdlib>
#include "attack.h"
#include "book.h"
#include "eval.h"
#include "fen.h"
#include "hash.h"
#include "init.h"
#include "main.h"
#include "material.h"
#include "make_move.h"
#include "option.h"
#include "pawn.h"
#include "probe.h"
#include "uci.h"
#include "pst.h"
#include "random.h"
#include "search.h"
#include "square.h"
#include "trans.h"
#include "value.h"
#include "distance.h"
#include "probe.h"
#include "search.h"

// functions

// main()
int main()
    {
    show_version();
    sprintf(file_name, "%s.cfg", ENGINE);
    attack_init();
    hash_init();
    move_do_init();
    random_init();
    option_init();
    piece_init();
    pawn_init_bit();
    square_init();
    util_init();
    value_init();
    vector_init();
    book_init();
    book_parameter();
    bitbase_parameter();
    trans_init(Trans);
    trans_parameter();
    threads_init();
    read_ini_file(file_name);
    start();
    return EXIT_SUCCESS;
    }
// end of main.cpp
