// pawn.h

#ifndef PAWN_H
#define PAWN_H

// macros
#define BIT(n)       (bit_eq[n])
#define BIT_FIRST(b) (bit_first[b])
#define BIT_LAST(b)  (bit_last[b])
#define BIT_COUNT(b) (bit_count[b])
#define WEAK_SQUARE_WHITE(sq) (board->square[sq-15] != ((1 << 2) | (1 << 0)) && board->square[sq-17] != ((1 << 2) | (1 << 0)))
#define WEAK_SQUARE_BLACK(sq) (board->square[sq+15] != ((1 << 3) | (1 << 1)) && board->square[sq+17] != ((1 << 3) | (1 << 1)))

// types
struct pawn_info_t
    {
    uint32 lock;
    sint16 opening;
    sint16 endgame;
    uint8 flags[2];
    uint8 passed_bits[2];
    uint8 single_file[2];
    uint16 pad;
    };

// variables
extern int bit_eq[16];
extern int bit_lt[16];
extern int bit_le[16];
extern int bit_gt[16];
extern int bit_ge[16];
extern int bit_first[0x100];
extern int bit_last[0x100];
extern int bit_count[0x100];
extern int bit_rev[0x100];

// functions
extern void pawn_init_bit();
extern void pawn_init();
extern void pawn_alloc();
extern void pawn_clear(int thread_id);
extern void pawn_get_info(pawn_info_t *info, const board_t *board, int thread_id);
extern int quad(int y_min, int y_max, int x);

#endif // !defined PAWN_H
// end of pawn.h
