// trans.h

#ifndef TRANPOSITION_H
#define TRANPOSITION_H

// macros
#define TRANS_IS_UPPER(flags) (((flags)&(1 << 0))!=0)
#define TRANS_IS_LOWER(flags) (((flags)&(1 << 1))!=0)
#define TRANS_IS_EXACT(flags) ((flags)==((1 << 0) | (1 << 1)))
struct entry_t
    {
    uint64 key;
    uint16 move;
    uint8 depth;
    uint8 date_flags;
    sint16 value;
    uint16 nproc;
    };

// types
typedef struct trans trans_t;

// variables
extern trans_t Trans[1];
extern bool trans_endgame;

// functions
extern void trans_parameter();
extern void trans_init(trans_t *trans);
extern void trans_alloc(trans_t *trans);
extern void trans_free(trans_t *trans);
extern void trans_clear(trans_t *trans);
extern void trans_inc_date(trans_t *trans);
extern void trans_store(trans_t *trans, uint64 key, int move, int depth, int flags, int value);
extern bool trans_retrieve(trans_t *trans, entry_t ** found_entry, uint64 key, int *move, int *depth, int *flags,
    int *value);
extern void trans_stats(const trans_t *trans);

#endif // !defined TRANPOSITION_H
// end of trans.h
