// values.cpp

// includes
#include "option.h"
#include "piece.h"
#include "search.h"
#include "util.h"
#include "value.h"

// variables
int value_piece[256];

// functions

// value_init()
void value_init()
    {
    int piece;

    // value_piece[]
    for (piece = 0; piece < 256; piece++)
        value_piece[piece] = -1;
    value_piece[0] = 0;
    value_piece[(1 << 4)] = 0;
    value_piece[((1 << 2) | (1 << 0))] = value_pawn;
    value_piece[((1 << 4) | (1 << 0))] = value_knight;
    value_piece[((1 << 5) | (1 << 0))] = value_bishop;
    value_piece[((1 << 6) | (1 << 0))] = value_rook;
    value_piece[(((1 << 5) | (1 << 6)) | (1 << 0))] = value_queen;
    value_piece[((1 << 7) | (1 << 0))] = value_king;
    value_piece[((1 << 3) | (1 << 1))] = value_pawn;
    value_piece[((1 << 4) | (1 << 1))] = value_knight;
    value_piece[((1 << 5) | (1 << 1))] = value_bishop;
    value_piece[((1 << 6) | (1 << 1))] = value_rook;
    value_piece[(((1 << 5) | (1 << 6)) | (1 << 1))] = value_queen;
    value_piece[((1 << 7) | (1 << 1))] = value_king;
    }

// value_is_mate()
bool value_is_mate(int value)
    {
    if(value < -(29744) || value > +(29744))
        return true;
    return false;
    }

// value_to_trans()
int value_to_trans(int value, int height)
    {
    if(value < -3000)
        {
        if(value < -(29744))
            value -= height;

        else if(value > -(29744))
            value -= 40 *height;
        }
    else if(value > +3000)
        {
        if(value > (29744))
            value += height;

        else if(value < +3000)
            value += 40 *height;
        }
    return value;
    }

// value_from_trans()
int value_from_trans(int value, int height)
    {
    if(value < -3000)
        {
        if(value < -(29744))
            value += height;

        else if(value > -(29744))
            value += 40 *height;
        }
    else if(value > +3000)
        {
        if(value > (29744))
            value -= height;

        else if(value < (29744))
            value -= 40 *height;
        }
    return value;
    }

// value_to_mate()
int value_to_mate(int value)
    {
    int dist;

    if(value < -(29744))
        {
        dist = (30000 + value) / 2;
        return -dist;
        }
    else if(value > +(29744))
        {
        dist = (30000 - value + 1) / 2;
        return +dist;
        }
    return 0;
    }
// end of values.cpp
