// value.h

#ifndef VALUES_H
#define VALUES_H

// constants
const int value_pawn = 100;
const int value_knight = 325;
const int value_bishop = 325;
const int value_rook = 500;
const int value_queen = 1000;
const int value_king = 10000;

// macros
#define VALUE_MATE(height) (-30000 + (height))
#define VALUE_PIECE(piece) (value_piece[piece])

// variables
extern int value_piece[256];

// functions
extern void value_init();
extern bool value_is_mate(int value);
extern int value_to_trans(int value, int height);
extern int value_from_trans(int value, int height);
extern int value_to_mate(int value);

#endif // !defined VALUES_H
// end of value.h
